"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var forms_1 = require("@angular/forms");
var CbForm = (function () {
    /**
     * Método constructor
     *
     * @param controllers
     */
    function CbForm(controllers) {
        /**
         * fBuilder
         *
         * @public
         * @type {FormBuilder}
         */
        this.builder = new forms_1.FormBuilder();
        /**
         * Controllers do formulario
         *
         */
        this.controllers = {};
        /**
         * Mensagens de erro
         *
         */
        this.errorMessages = [];
        this.controllers = controllers;
    }
    /**
     * errors
     *
     * retorna os erros existentes em um campo
     *
     * @param {string} key nome do item do formulário
     */
    CbForm.prototype.errors = function (key, customMessages) {
        if (customMessages === void 0) { customMessages = {}; }
        // pega o controlador
        var fControl = this.controllers[key];
        // se ele existir
        if (fControl) {
            // verifica se existem errors
            if (fControl.errors && fControl.invalid && fControl.dirty && fControl.touched) {
                // seta o array de retorno
                var retorno = new Array();
                // percorre todos os erros
                for (var e in fControl.errors) {
                    var msg = (this.errorMessages[e]) ? this.errorMessages[e] : "Nenhuma mensagem encontrada para o erro " + e;
                    msg = (customMessages[e]) ? customMessages[e] : msg;
                    retorno.push(msg);
                }
                // volta as mensagens
                return retorno;
            }
            else
                return false;
        }
        else
            return false;
    };
    /**
     * control
     *
     * retorna um controller especifico do formulario
     *
     * @param {string} key nome do item do formulário
     */
    CbForm.prototype.control = function (key) {
        return (this.controllers[key]) ? this.controllers[key] : null;
    };
    /**
     * Obtem o form que devera ser colocado no HTML
     *
     */
    CbForm.prototype.html = function () {
        return this.builder.group(this.controllers);
    };
    return CbForm;
}());
exports.default = CbForm;
// End of file
//# sourceMappingURL=form.class.js.map