"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var forms_1 = require("@angular/forms");
var core_1 = require("@angular/core");
var form_class_1 = require("./form.class");
var CbValidator = (function () {
    function CbValidator() {
        /**
         * fBuilder
         *
         * @public
         * @type {FormBuilder}
         */
        this.fBuilder = new forms_1.FormBuilder();
        /**
         * Mensagens de erro
         *
         */
        this.errorMessages = [];
        /**
         * Regras personalizadas
         *
         */
        this.customRules = {};
    }
    /**
     * Seta os controllers do form
     *
     * @param rules
     */
    CbValidator.prototype.__parseControllers = function (rules) {
        // objeto que contera os forms controller
        var formControlObject = {};
        // percorre todas as regras
        for (var r in rules) {
            // pega o array de validadores
            var validatorsArray = this.__getValidatorsArray(rules[r], r);
            // adiciona um novo FormControl
            formControlObject[r] = new forms_1.FormControl(null, validatorsArray);
        }
        // retorna o objeto de formControl
        return formControlObject;
    };
    /**
     * Gera um novo formulário
     *
     * @param {Array<Object>} rules all rules
     */
    CbValidator.prototype.build = function (rules) {
        // Cria um novo formulário
        return new form_class_1.default(this.__parseControllers(rules));
    };
    /**
     * Cria uma nova regra
     *
     * @param rule
     */
    CbValidator.prototype.createRule = function (rule) {
        this.customRules[rule.name] = rule;
    };
    /**
     * __getValidatorsArray
     *
     * seta uma array de validadores customizados
     *
     * @private
     * @author Gustavo Vilas Boas
     * @since 02-2017
     * @param {string} rules all rules
     */
    CbValidator.prototype.__getValidatorsArray = function (rules, field) {
        // verifica se existem regras
        if (!rules)
            return new Array();
        // separa as regras de validação
        var rulesArray = rules.split('|');
        // declara o array de retorno
        var retorno = [];
        // percorre todas as regras
        for (var r in rulesArray) {
            // verifica se existe []
            if (rulesArray[r].indexOf('[') !== -1 && rulesArray[r].indexOf(']') !== -1) {
                // separa a string
                var parts = rulesArray[r].split(/[[\]]{1,2}/);
                parts.length--;
                // Adiciona a regra
                var toPush = this.customRules[parts[0]] ? this.customRules[parts[0]](parts[1]) : forms_1.Validators[parts[0]](parts[1]);
                retorno.push(toPush);
            }
            else {
                // Adiciona a regra
                var toPush = this.customRules[r] ? this.customRules[r] : forms_1.Validators[r];
                retorno.push(toPush);
            }
        }
        // retorna as regras
        return retorno;
    };
    CbValidator = __decorate([
        core_1.Injectable()
    ], CbValidator);
    return CbValidator;
}());
exports.CbValidator = CbValidator;
// End of file
//# sourceMappingURL=validator.provider.js.map