import { FormGroup, FormBuilder } from '@angular/forms';
export default class CbForm {
    /**
     * fBuilder
     *
     * @public
     * @type {FormBuilder}
     */
    builder: FormBuilder;
    /**
     * Controllers do formulario
     *
     */
    controllers: {};
    /**
     * Mensagens de erro
     *
     */
    errorMessages: {};
    /**
     * Método constructor
     *
     * @param controllers
     */
    constructor(controllers: any, errorMessages: any);
    /**
     * errors
     *
     * retorna os erros existentes em um campo
     *
     * @param {string} key nome do item do formulário
     */
    errors(key: string, customMessages?: {}): boolean | Array<string>;
    /**
     * control
     *
     * retorna um controller especifico do formulario
     *
     * @param {string} key nome do item do formulário
     */
    control(key: string): any;
    /**
     * Obtem o form que devera ser colocado no HTML
     *
     */
    html(): FormGroup;
}
