import { FormControl } from '@angular/forms';
export default class Rule {
    /**
     * Label da regra
     *
     */
    label: string;
    /**
     * Nome da regra
     *
     */
    name: string;
    /**
     * Callback que valida a regra
     *
     */
    validator: any;
    /**
     * Método constructor
     *
     * @param name nome da regra
     * @param validator função de validação
     * @param label label da regra
     */
    constructor(name: string, validator: (control: FormControl) => any, label: string);
    /**
     * Verifica se um determinado valor é válido para essa regra
     *
     * @param value
     */
    valid(value: any): any;
}
