import { FormBuilder } from '@angular/forms';
import CbForm from './form.class';
import Rule from './rule.class';
export declare class CbValidator {
    /**
     * fBuilder
     *
     * @public
     * @type {FormBuilder}
     */
    fBuilder: FormBuilder;
    /**
     * Mensagens de erro
     *
     */
    errorMessages: {
        required: string;
        maxLength: string;
        minLength: string;
    };
    /**
     * Regras personalizadas
     *
     */
    customRules: {};
    /**
     * Seta os controllers do form
     *
     * @param rules
     */
    private __parseControllers(rules);
    /**
     * Gera um novo formulário
     *
     * @param {Array<Object>} rules all rules
     */
    build(rules: {}): CbForm;
    /**
     * Cria uma nova regra
     *
     * @param rule
     */
    createRule(rule: Rule): void;
    /**
     * __getValidatorsArray
     *
     * seta uma array de validadores customizados
     *
     * @private
     * @author Gustavo Vilas Boas
     * @since 02-2017
     * @param {string} rules all rules
     */
    private __getValidatorsArray(rules, field);
}
