import { Component } from '@angular/core';
import { CbValidator } from '../../../../src/validator.provider';
import CbForm from '../../../../src/form.class';
import Rule from '../../../../src/rule.class';

@Component({
  selector: 'page-home',
  templateUrl: 'home.html'
})
export class HomePage {

  form: CbForm;

  constructor(public validator: CbValidator ) {

    this.validator.errorMessages = {
      required: "Esse campo é obrigatório"
    };

    const rule = new Rule( 'bigger', ( control ) => {
      if ( control ) {
        if ( control.value > 2 ) {
          return { bigger: true };
        } else {
          return null;
        }
      } else return null;
    }, 'Maior' );

    const rules = {
      name: 'required|bigger',
    };
    this.validator.createRule( rule );
    this.form = this.validator.build( rules );
  } 
}
